clear all;
close all;
clc;

tol = 1e-15;

%Testcase 1
n = 4;
A = [-2 -1 1 3; 1 3 -1 -1; 1 1 -3 1; -1 2 1 -1];
[L1,R1,P1] = myLuRows(A);
[L2,R2,P2] = myLuCols(A);

err1 = max(max(abs(L1*R1-A*P1)));
err2 = max(max(abs(L2*R2-P2*A)));

if (err1 < tol) && (err2 < tol)
    fprintf('Testcase 1: Passed.\n')
else
    fprintf(2,'Testcase 1: Failed.\n')
end

%Testcase 2
n = 7;
A = rand(n);
[L1,R1,P1] = myLuRows(A);
[L2,R2,P2] = myLuCols(A);

err1 = max(max(abs(L1*R1-A*P1)));
err2 = max(max(abs(L2*R2-P2*A)));

if (err1 < tol) && (err2 < tol)
    fprintf('Testcase 2: Passed.\n')
else
    fprintf(2,'Testcase 2: Failed.\n')
end


%Testcase 3
n = 25;
A = rand(n);
[L1,R1,P1] = myLuRows(A);
[L2,R2,P2] = myLuCols(A);

err1 = max(max(abs(L1*R1-A*P1)));
err2 = max(max(abs(L2*R2-P2*A)));

if (err1 < tol) && (err2 < tol)
    fprintf('Testcase 3: Passed.\n')
else
    fprintf(2,'Testcase 3: Failed.\n')
end